/* Hekr '48-Passthrough' Protocol
 * Copyright(c) 2018 Hangzhou District Nine Technology Co., Ltd.  */

#ifndef HEKR48TRANS_H
#define HEKR48TRANS_H

#include "ra_types.h"

typedef enum
{
    H48_FRAME_TYPE_UNKNOWN,
    H48_FRAME_TYPE_APPSEND,
} h48_frame_type;

int raw_to_hexlit(char *dst, const ra_u8 *src, ra_size_t len);

int hexlit_to_raw(ra_u8 *dst, const char *src, const ra_size_t len);

int hexlit_to_raw16(ra_u16 *dst, const char *src, const ra_size_t len);

int h48_build_frame_verify_request(ra_u8 *buf, const ra_size_t buf_size, const ra_u8 frame_num, \
        const char *prodkey, const char *devtid);

int h48_build_frame_verify(ra_u8 *buf, const ra_size_t buf_size, const ra_u8 frame_num, \
        const char *randomkey, const char *devtid, const char *devprikey);

int h48_build_frame_heartbeat(ra_u8 *buf, const ra_size_t buf_size, const ra_u8 frame_num);

int h48_build_frame_devsend(ra_u8 *buf, const ra_size_t buf_size, const ra_u8 frame_num, const ra_u16 msgid, \
        const ra_u8 *data, const ra_size_t data_len);

int h48_build_frame_appsendresp(ra_u8 *buf, const ra_size_t buf_size, const ra_u8 frame_num, const ra_u16 msgid, \
        const ra_u8 *apptid);

h48_frame_type h48_frame_decode_type(ra_u8 *frame, const ra_size_t frame_size);

#endif

